%define name		openejb
%define version		2.0
%define mstone		M2
%define release		0.%{mstone}.2jpp
%define	section		free


Name:		%{name}
Summary:	EJB Container System and EJB Server
Url:		http://www.openejb.org/
Version:	%{version}
Release:	%{release}
Epoch:		0
License:	Apache Software License 2
Group:		Development/Libraries/Java
Vendor:		JPackage Project
Distribution:	JPackage
BuildArch:	noarch
Source0:	openejb-2.0-M2-src.tar.gz
# cvs -d:pserver:anon@cvs.openejb.codehaus.org:/scm/openejb login
# cvs -d:pserver:anon@cvs.openejb.codehaus.org:/scm/openejb export -r v2_0_M2 openejb
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        openejb-2.0-M2-jpp-depmap.xml


Patch0:		openejb-2.0-M2-jpp.patch
Patch1:		openejb-2.0-M2-CMPMappingBean.patch

BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:	junit
BuildRequires:	maven
BuildRequires:	saxon, saxon-scripts
#
BuildRequires:	ant >= 0:1.6
BuildRequires:	asm >= 0:1.4.3
BuildRequires:	axion >= 0:1.0-0.M3
BuildRequires:	castor >= 0:0.9.6
BuildRequires:	cglib >= 0:2.0.2
BuildRequires:	concurrent
BuildRequires:	geronimo-modules >= 0:1.0-0.M2
BuildRequires:	geronimo-specs >= 0:1.0-0.M2
BuildRequires:	howl-logger >= 0:0.1.7
BuildRequires:	jakarta-commons-cli
BuildRequires:	jakarta-commons-collections >= 0:3.1
BuildRequires:	jakarta-commons-fileupload
BuildRequires:	jakarta-commons-jelly-tags-velocity >= 0:1.0-0.rc1
BuildRequires:	jakarta-commons-logging
BuildRequires:	jakarta-commons-primitives
BuildRequires:	jaxen >= 0:1.1
BuildRequires:	log4j
BuildRequires:	mx4j >= 0:2.0.1
BuildRequires:	regexp
BuildRequires:	tranql >= 0:1.0-0.M2
BuildRequires:	tranql-connector >= 0:1.0-0.M2
BuildRequires:	velocity >= 0:1.4
BuildRequires:	xerces-j2
BuildRequires:	xmlbeans
BuildRequires:	xml-commons-apis
BuildRequires:	xml-commons-resolver
BuildRequires:	xpp3
BuildRequires:	xstream 
#
Requires:	ant >= 0:1.6
Requires:	asm >= 0:1.4.3
Requires:	axion >= 0:1.0-0.M3
Requires:	castor >= 0:0.9.6
Requires:	cglib >= 0:2.0.2
Requires:	concurrent
Requires:	geronimo-modules >= 0:1.0-0.M2
Requires:	geronimo-specs >= 0:1.0-0.M2
Requires:	howl-logger >= 0:0.1.7
Requires:	jakarta-commons-cli
Requires:	jakarta-commons-collections >= 0:3.1
Requires:	jakarta-commons-fileupload
Requires:	jakarta-commons-jelly-tags-velocity >= 0:1.0-0.rc1
Requires:	jakarta-commons-logging
Requires:	jakarta-commons-primitives
Requires:	jaxen >= 0:1.1
Requires:	log4j
Requires:	mx4j >= 0:2.0.1
Requires:	regexp
Requires:	tranql >= 0:1.0-0.M2
Requires:	tranql-connector >= 0:1.0-0.M2
Requires:	velocity >= 0:1.4
Requires:	xerces-j2
Requires:	xmlbeans
Requires:	xml-commons-apis
Requires:	xml-commons-resolver
Requires:	xpp3
Requires:	xstream 

#
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
OpenEJB is an open source, modular, configurable, and extendable EJB Container System 
and EJB Server.
OpenEJB comes with fast, lightweight EJB Servers for both Local and Remote access. 
That's right, deploy your EJBs into the container system, then just start the 
Remote EJB Server from the command line! Or, put OpenEJB in your class path and 
use it as an embedded library through the Local EJB Server.
As a container system, OpenEJB works like a big plug-in for middleware servers 
like Web servers, CORBA servers, and application servers. By plugging in OpenEJB 
these servers obtain instant EJB compliance for hosting Enterprise JavaBeans! 

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{name}
chmod -R go=u-w *
find . -name "*.jar" -exec rm -f {} \;

export DEPCAT=$(pwd)/openejb-2.0-M2-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > openejb-2.0-M2-depmap.new.xml


%patch0 -b .sav
%patch1 -b .sav

%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

mkdir -p .maven/repository/JPP/jars
build-jar-repository .maven/repository/JPP/jars \
commons-collections \
commons-jelly-tags-html \
nekohtml \
xmlbeans/xbean \


mkdir -p .maven/repository/maven/jars
build-jar-repository .maven/repository/maven/jars \
maven-jelly-tags \



#xml-commons-resolver \


pushd .maven/repository/JPP/jars
ln -sf $(build-classpath ant) ant.jar
ln -sf $(build-classpath asm/asm) asm-asm.jar
ln -sf $(build-classpath axion) axion.jar
ln -sf $(build-classpath castor) castor.jar
ln -sf $(build-classpath cglib) cglib.jar
ln -sf $(build-classpath commons-cli) commons-cli.jar
ln -sf $(build-classpath commons-collections) commons-collections.jar
ln -sf $(build-classpath commons-fileupload) commons-fileupload.jar
ln -sf $(build-classpath commons-jelly-tags-velocity) commons-jelly-tags-velocity.jar
ln -sf $(build-classpath commons-logging) commons-logging.jar
ln -sf $(build-classpath commons-primitives) commons-primitives.jar
ln -sf $(build-classpath concurrent) concurrent.jar
ln -sf $(build-classpath geronimo/spec-j2ee-deployment-1.1) geronimo-spec-j2ee-deployment-1.1.jar
ln -sf $(build-classpath howl-logger) howl-logger.jar
ln -sf $(build-classpath jaxen) jaxen.jar
ln -sf $(build-classpath junit) junit.jar
ln -sf $(build-classpath log4j) log4j.jar
ln -sf $(build-classpath mx4j/mx4j) mx4j-mx4j.jar
ln -sf $(build-classpath mx4j/mx4j-jmx) mx4j-mx4j-jmx.jar
ln -sf $(build-classpath mx4j/mx4j-remote) mx4j-mx4j-remote.jar
ln -sf $(build-classpath regexp) regexp.jar
ln -sf $(build-classpath tranql) tranql.jar
ln -sf $(build-classpath velocity) velocity.jar
ln -sf $(build-classpath xerces-j2) xerces-j2.jar
ln -sf $(build-classpath xml-commons-apis) xml-commons-apis.jar
ln -sf $(build-classpath xml-commons-resolver) xml-commons-resolver.jar
ln -sf $(build-classpath xmlbeans/xbean) xmlbeans-xbean.jar
ln -sf $(build-classpath xpp3) xpp3.jar
ln -sf $(build-classpath xstream) xstream.jar
popd

mkdir -p .maven/repository/JPP/rars
pushd .maven/repository/JPP/rars
ln -sf /usr/share/java/tranql-connector.rar .
popd


mkdir -p .maven/repository/geronimo-spec/jars
pushd .maven/repository/geronimo-spec/jars
ln -sf $(build-classpath geronimo/spec-ejb-2.1) geronimo-spec-ejb-2.1-rc2.jar
ln -sf $(build-classpath geronimo/spec-j2ee-1.4) geronimo-spec-j2ee-1.4-rc2.jar
ln -sf $(build-classpath geronimo/spec-j2ee-connector-1.5) geronimo-spec-j2ee-connector-1.5-rc2.jar
ln -sf $(build-classpath geronimo/spec-j2ee-deployment-1.1) geronimo-spec-j2ee-deployment-1.1-rc2.jar
ln -sf $(build-classpath geronimo/spec-j2ee-jacc-1.0) geronimo-spec-j2ee-jacc-1.0-rc2.jar
ln -sf $(build-classpath geronimo/spec-j2ee-management-1.0) geronimo-spec-j2ee-management-1.0-rc2.jar
ln -sf $(build-classpath geronimo/spec-j2eeschema-1.0) geronimo-spec-j2eeschema-1.0-rc2.jar
ln -sf $(build-classpath geronimo/spec-jms-1.1) geronimo-spec-jms-1.1-rc2.jar
ln -sf $(build-classpath geronimo/spec-jta-1.0.1B) geronimo-spec-jta-1.0.1B-rc2.jar
ln -sf $(build-classpath geronimo/spec-servlet-2.4) geronimo-spec-servlet-2.4-rc2.jar
popd

mkdir -p .maven/repository/geronimo/jars
pushd .maven/repository/geronimo/jars
ln -sf $(build-classpath geronimo/clustering) geronimo-clustering-1.0-M2.jar
ln -sf $(build-classpath geronimo/common) geronimo-common-1.0-M2.jar
ln -sf $(build-classpath geronimo/connector) geronimo-connector-1.0-M2.jar
ln -sf $(build-classpath geronimo/core) geronimo-core-1.0-M2.jar
ln -sf $(build-classpath geronimo/deployment) geronimo-deployment-1.0-M2.jar
ln -sf $(build-classpath geronimo/j2ee) geronimo-j2ee-1.0-M2.jar
ln -sf $(build-classpath geronimo/j2ee-schema) geronimo-j2ee-schema-1.0-M2.jar
ln -sf $(build-classpath geronimo/jmxremoting) geronimo-jmxremoting-1.0-M2.jar
ln -sf $(build-classpath geronimo/jetty) geronimo-jetty-1.0-M2.jar
ln -sf $(build-classpath geronimo/kernel) geronimo-kernel-1.0-M2.jar
ln -sf $(build-classpath geronimo/naming) geronimo-naming-1.0-M2.jar
ln -sf $(build-classpath geronimo/network) geronimo-network-1.0-M2.jar
ln -sf $(build-classpath geronimo/remoting) geronimo-remoting-1.0-M2.jar
ln -sf $(build-classpath geronimo/security) geronimo-security-1.0-M2.jar
ln -sf $(build-classpath geronimo/system) geronimo-system-1.0-M2.jar
ln -sf $(build-classpath geronimo/timer) geronimo-timer-1.0-M2.jar
ln -sf $(build-classpath geronimo/transaction) geronimo-transaction-1.0-M2.jar
popd

mkdir -p .maven/repository/geronimo/plugins
pushd .maven/repository/geronimo/plugins
ln -sf $(build-classpath geronimo/xmlbeans-plugin) geronimo-xmlbeans-plugin-1.0-M2.jar
ln -sf $(build-classpath geronimo/deployment-plugin) geronimo-deployment-plugin-1.0-M2.jar
popd

maven   -Dgeronimo_spec_j2ee_version=1.4-rc2 \
	-Dgeronimo_version=1.0-M2 \
	-Dopenejb_version=2.0-M2 \
	-Ditest.skip=true \
	-Dmaven.home.local=$(pwd)/.maven \
	default javadoc xdoc:jelly-transform

#for md in connector  core  itests  webadmin; do
#	pushd modules/$md
#	maven javadoc:generate
#	popd
#done

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 \
	modules/assembly/target/%{name}-assembly-%{version}-%{mstone}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/assembly-%{version}.jar
install -m 644 \
	modules/connector/target/%{name}-jca-%{version}-%{mstone}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jca-%{version}.jar
install -m 644 \
	modules/connector/target/%{name}-jca-%{version}-%{mstone}.rar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jca-%{version}.rar
install -m 644 \
	modules/core/target/%{name}-core-%{version}-%{mstone}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 \
	modules/itests/target/%{name}-itests-%{version}-%{mstone}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/itests-%{version}.jar
install -m 644 \
	modules/webadmin/target/%{name}-webadmin-%{version}-%{mstone}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/webadmin-%{version}.jar
install -m 644 modules/webadmin/target/%{name}-webadmin-clienttools.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/webadmin-clienttools-%{version}.jar
install -m 644 modules/webadmin/target/%{name}-webadmin-ejbgen.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/webadmin-ejbgen-%{version}.jar
install -m 644 modules/webadmin/target/%{name}-webadmin-main.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/webadmin-main-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)


# server
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/bin
install -m 755 modules/core/src/bin/openejb \
        $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/bin
install -m 755 modules/itests/src/bin/openejb-tests \
        $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/bin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
install -m 644 modules/core/src/conf/*.xml \
        $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
install -m 644 modules/core/src/conf/*.conf \
        $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/lib
install -d -m 755 $RPM_BUILD_ROOT%{_localstatedir}/log/%{name}
ln -sf %{_localstatedir}/log/%{name} \
        $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/logs

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
for md in connector core webadmin; do
        install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/$md
        cp -pr modules/$md/target/docs/apidocs/* \
                $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/$md
done
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink


%clean
rm -rf $RPM_BUILD_ROOT

%preun
pushd %{_datadir}/%{name}-%{version}/lib
rm -f *.jar
popd

%post
pushd %{_datadir}/%{name}-%{version}/lib
rm -f *.jar

ln -sf $(build-classpath asm/asm) .
ln -sf $(build-classpath axion) .
ln -sf $(build-classpath castor) .
ln -sf $(build-classpath cglib) .
ln -sf $(build-classpath commons-fileupload) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath commons-primitives) .
ln -sf $(build-classpath concurrent) .
ln -sf $(build-classpath geronimo/common) geronimo-common.jar
ln -sf $(build-classpath geronimo/connector) geronimo-connector.jar
ln -sf $(build-classpath geronimo/core) geronimo-core.jar
ln -sf $(build-classpath geronimo/deployment) geronimo-deployment.jar
ln -sf $(build-classpath geronimo/j2ee) geronimo-j2ee.jar
ln -sf $(build-classpath geronimo/j2ee-schema) geronimo-j2ee-schema.jar
ln -sf $(build-classpath geronimo/jmxremoting) geronimo-jmxremoting.jar
ln -sf $(build-classpath geronimo/kernel) geronimo-kernel.jar
ln -sf $(build-classpath geronimo/naming) geronimo-naming.jar
ln -sf $(build-classpath geronimo/remoting) geronimo-remoting.jar
ln -sf $(build-classpath geronimo/security) geronimo-security.jar
ln -sf $(build-classpath geronimo/spec-ejb-2.1) geronimo-spec-ejb-2.1.jar
ln -sf $(build-classpath geronimo/spec-j2ee-1.4) geronimo-spec-j2ee-1.4.jar
ln -sf $(build-classpath geronimo/system) geronimo-system.jar
ln -sf $(build-classpath geronimo/timer) geronimo-timer.jar
ln -sf $(build-classpath geronimo/transaction) geronimo-transaction.jar
ln -sf $(build-classpath howl-logger) .
ln -sf $(build-classpath log4j) .
ln -sf $(build-classpath openejb/core) openejb-core.jar
ln -sf $(build-classpath openejb/jca) openejb-jca.jar
ln -sf $(build-classpath regexp) .
ln -sf $(build-classpath tranql) .
ln -sf $(build-classpath xerces-j2) .
popd


%files
%defattr(-,root,root)
%{_javadir}/*
%{_datadir}/%{name}-%{version}/*
%{_localstatedir}/log/%{name}

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Thu May 19 2005 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.M2.2jpp
- Patch to castor-0.9.6

* Thu Feb 03 2005 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.M2.1jpp
- Upgrade to 2.0-M2
- Process project.xml files with saxon
- Don't tamper with $HOME

* Mon Oct 04 2004 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.M1.1jpp
- First release

